package core;


import java.util.List;
 
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;
 
public class JavaReadWriteHDFS {
 
    public static void main(String[] args) {
 
        if (args.length < 2) {
            System.err.println("Please provide the input file full path as argument");
            System.exit(0);
        }
 
        SparkConf conf = new SparkConf().setAppName("java.ReadFromHdfs").setMaster("local");
        JavaSparkContext context = new JavaSparkContext(conf);
        
        
        /*
        The "args[0]" can be a single text file or a directory that contains multiple 
        files. The "JavaRDD" will contain individual records from the file(s). 
        Useful to process CSV files that can be split by records.
        
        args[0] can be

			1) A file: hdfs://localhost:9000/sampledata/sample.txt

			2) a folder with many files: hdfs://localhost:8020/sampledata
         
         */
        
        JavaRDD<String> textFile = context.textFile(args[0]);
        
        
        
        List<String> listCsvLines = textFile.collect();
        System.out.println("========= " + listCsvLines);
        
        /*
        args[1] can be a folder: hdfs://localhost:9000/out
         
         */
        
        textFile.saveAsTextFile(args[1]);
        
        context.close();
    }
}
